/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2011-2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2014 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2014 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2014 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2014 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: Os.h 492 2014-09-29 05:35:11Z t_ishikawa $
 */

/*
 *		ATK2 OSإåե
 *
 *  ATK2ݡȤ륷ƥॵӥȡɬפʥǡ
 *  ޥޤإåե
 *
 *  ֥Υե뤫餳Υե򥤥󥯥롼ɤ
 *  ϡTOPPERS_MACRO_ONLYƤ
 *  ˤꡤޥʳ褦ˤʤäƤ
 *
 *  Υե򥤥󥯥롼ɤ˥󥯥롼ɤƤ٤ե
 *  Ϥʤ
 */

#ifndef TOPPERS_OS_H
#define TOPPERS_OS_H

/*
 *  ̤Υǡޥ
 */
#include "Std_Types.h"
#include "MemMap.h"
#include "Rte_Os_Type.h"

#if !defined(TOPPERS_CFG1_OUT) && !defined(OMIT_INCLUDE_OS_CFG)
#include "Os_Cfg.h"
#endif

/*
 *  åȰ¸
 */
#include "target_kernel.h"

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ǡ
 */

/*
 *  ֹ֥η
 */
typedef uint8	TaskStateType;              /*  */
typedef uint32	EventMaskType;              /* ٥ȥޥ */
typedef uint32	TickType;                   /* ͡ʥƥå*/
typedef uint32	AppModeType;                /* ץꥱ⡼ */
typedef uint8	OSServiceIdType;            /* ƥॵӥID */
typedef uint8	ScheduleTableStatusType;    /* 塼ơ֥ */
typedef uint8	ProtectionReturnType;       /* ץƥեå֤ */
typedef uintptr	MemorySizeType;             /* ΰ襵 */
typedef uint8	ApplicationType;            /* OSץꥱID */
typedef uint8	ObjectTypeType;             /* OS֥ȼ */

typedef struct {
	TickType	maxallowedvalue;            /* 󥿻κ */
	TickType	ticksperbase;               /* OSǤϻѤ桼ͳ˻Ѥ */
	TickType	mincycle;                   /* κǾ */
} AlarmBaseType;

typedef enum {
	TRYTOGETSPINLOCK_SUCCESS,
	TRYTOGETSPINLOCK_NOSUCCESS
} TryToGetSpinlockType;

/*
 *  Ŭ뤿ᡤ¸Ǥ뷿
 */
#ifndef OMIT_DATA_TYPE
typedef uint32	TimeType;                   /*  */
typedef uint32	AlarmType;                  /* 顼ID */
typedef uint32	ResourceType;               /* ꥽ID */
typedef uint32	TaskType;                   /* ID */
typedef uint32	ISRType;                    /* ISR ID */
typedef uint32	CounterType;                /* ID */
typedef uint32	ScheduleTableType;          /* 塼ơ֥ID */
typedef float32	PhysicalTimeType;           /* ʥƥå֤˴ѡ˻ */
typedef uint8	CoreIdType;                 /* ID */
typedef uint32	SpinlockIdType;             /* ԥåID */
typedef uint32	IocType;                    /* IOC ID */
typedef uint8	SenderIdType;               /* Sender ID */
#endif /* OMIT_DATA_TYPE */

typedef AlarmBaseType *				AlarmBaseRefType;
typedef TaskType *					TaskRefType;
typedef TaskStateType *				TaskStateRefType;
typedef EventMaskType *				EventMaskRefType;
typedef TickType *					TickRefType;
typedef ScheduleTableStatusType *	ScheduleTableStatusRefType;

/*
 *  ݸȿ򵯤ñ̤η
 */
typedef uint8 FaultyContextType;

/*
 *  OS֥ѤΥޥ
 */
#define DeclareTask(TaskIdentifier)
#define DeclareResource(ResourceIdentifier)
#define DeclareEvent(EventIdentifier)
#define DeclareAlarm(AlarmIdentifier)

/*
 *  ᥤ롼ѤΥޥ
 */
#define TASK(TaskName)	void TaskMain  ## TaskName(void)
#define ISR(ISRName)	void ISRMain   ## ISRName(void)
#ifndef C1ISR
#define C1ISR(ISRName)	void C1ISRMain ## ISRName(void)
#endif /* C1ISR */
#define ICISR(ICIName)	void ICIMain   ## ICIName(void)
#define ALARMCALLBACK(AlarmCallBackName) \
	void AlarmMain ## AlarmCallBackName(void)

/*
 *  ΰݤΤη
 */
#ifndef TOPPERS_STK_T
#define TOPPERS_STK_T	sintptr
#endif /* TOPPERS_STK_T */
typedef	TOPPERS_STK_T StackType;    /* åΰݤ뤿η */

/*
 *  ƥॵӥѥ᡼Τ
 */
typedef union {
	TaskType					tskid;
	TaskRefType					p_tskid;
	TaskStateRefType			p_stat;
	ResourceType				resid;
	EventMaskType				mask;
	EventMaskRefType			p_mask;
	AlarmType					almid;
	AlarmBaseRefType			p_info;
	TickRefType					p_tick;
	TickRefType					p_val;
	TickRefType					p_eval;
	TickType					incr;
	TickType					cycle;
	TickType					start;
	AppModeType					mode;
	CounterType					cntid;
	ScheduleTableType			schtblid;
	TickType					offset;
	ScheduleTableType			schtblid_from;
	ScheduleTableType			schtblid_to;
	ScheduleTableStatusRefType	p_schtblstate;
	ISRType						isrid;
	CoreIdType					coreid;
	StatusType					*status;
	SpinlockIdType				spnid;
	TryToGetSpinlockType		*tryspntype;
	IocType						iocid;
	SenderIdType				senderid;
} _ErrorHook_Par;

/*
 *  ΰݤΤΥޥ
 *
 *  ʲTOPPERS_COUNT_SZTOPPERS_ROUND_SZϡunit2ζҾǤ
 *  뤳ȤꤷƤ롥
 */
#ifndef TOPPERS_COUNT_SZ
#define TOPPERS_COUNT_SZ(sz, unit)	(((sz) + (unit) - (1U)) / (unit))
#endif /* TOPPERS_COUNT_SZ */
#ifndef TOPPERS_ROUND_SZ
#define TOPPERS_ROUND_SZ(sz, unit)	(((sz) + (unit) - (1U)) & (~((unit) - (1U))))
#endif /* TOPPERS_ROUND_SZ */

#define COUNT_STK_T(sz)		(TOPPERS_COUNT_SZ((sz), sizeof(StackType)))
#define ROUND_STK_T(sz)		(TOPPERS_ROUND_SZ((sz), sizeof(StackType)))

/*
 *  ƥॵӥAPI
 */

/*
 *  OS
 */
extern AppModeType GetActiveApplicationMode(void);
extern void StartOS(AppModeType Mode);
extern void ShutdownAllCores(StatusType Error);
extern FaultyContextType GetFaultyContext(void);

/*
 *  
 */
extern StatusType ActivateTask(TaskType TaskID);
extern StatusType TerminateTask(void);
extern StatusType ChainTask(TaskType TaskID);
extern StatusType Schedule(void);
extern StatusType GetTaskID(TaskRefType TaskID);
extern StatusType GetTaskState(TaskType TaskID, TaskStateRefType State);

/*
 *  ߴ
 */
extern void EnableAllInterrupts(void);
extern void DisableAllInterrupts(void);
extern void ResumeAllInterrupts(void);
extern void SuspendAllInterrupts(void);
extern void ResumeOSInterrupts(void);
extern void SuspendOSInterrupts(void);
extern ISRType GetISRID(void);

/*
 *  ٥ȴ
 */
extern StatusType SetEvent(TaskType TaskID, EventMaskType Mask);
extern StatusType ClearEvent(EventMaskType Mask);
extern StatusType GetEvent(TaskType TaskID, EventMaskRefType Event);
extern StatusType WaitEvent(EventMaskType Mask);

/*
 *  ꥽
 */
extern StatusType GetResource(ResourceType ResID);
extern StatusType ReleaseResource(ResourceType ResID);

/*
 *  
 */
extern StatusType IncrementCounter(CounterType CounterID);

/*
 *  եȥե꡼󥿥
 */
extern StatusType GetCounterValue(CounterType CounterID, TickRefType Value);
extern StatusType GetElapsedValue(CounterType CounterID, TickRefType Value, TickRefType ElapsedValue);

/*
 *  顼
 */
extern StatusType GetAlarmBase(AlarmType AlarmID, AlarmBaseRefType Info);
extern StatusType GetAlarm(AlarmType AlarmID, TickRefType Tick);
extern StatusType SetRelAlarm(AlarmType AlarmID, TickType increment, TickType cycle);
extern StatusType SetAbsAlarm(AlarmType AlarmID, TickType start, TickType cycle);
extern StatusType CancelAlarm(AlarmType AlarmID);

/*
 *  塼ơ֥
 */
extern StatusType StartScheduleTableRel(ScheduleTableType ScheduleTableID, TickType Offset);
extern StatusType StartScheduleTableAbs(ScheduleTableType ScheduleTableID, TickType Start);
extern StatusType StopScheduleTable(ScheduleTableType ScheduleTableID);
extern StatusType NextScheduleTable(ScheduleTableType ScheduleTableID_From, ScheduleTableType ScheduleTableID_To);
extern StatusType GetScheduleTableStatus(ScheduleTableType ScheduleTableID, ScheduleTableStatusRefType ScheduleStatus);

/*
 *  OSAP
 */
extern ApplicationType GetApplicationID(void);
extern ApplicationType CheckTaskOwnership(TaskType TaskID);
extern ApplicationType CheckISROwnership(ISRType ISRID);
extern ApplicationType CheckAlarmOwnership(AlarmType AlarmID);
extern ApplicationType CheckCounterOwnership(CounterType CounterID);
extern ApplicationType CheckScheduleTableOwnership(ScheduleTableType ScheduleTableID);

/*
 *  ޥϢ
 */
extern uint32 GetNumberOfActivatedCores(void);
extern CoreIdType GetCoreID(void);
extern void StartCore(CoreIdType CoreID, StatusType *Status);
extern void StartNonAutosarCore(CoreIdType CoreID, StatusType *Status);
extern StatusType GetSpinlock(SpinlockIdType SpinlockId);
extern StatusType ReleaseSpinlock(SpinlockIdType SpinlockId);
extern StatusType TryToGetSpinlock(SpinlockIdType SpinlockId, TryToGetSpinlockType *Success);
extern StatusType RaiseInterCoreInterrupt(ISRType ISRID);

/*
 *  IOCϢ
 */
extern Std_ReturnType ioc_send_generic(IocType IocWrapperId, const void *in);
extern Std_ReturnType ioc_write_generic(IocType IocWrapperId, const void *in);
extern Std_ReturnType ioc_receive_generic(IocType IocId, void *out);
extern Std_ReturnType ioc_read_generic(IocType IocId, void *out);
extern Std_ReturnType ioc_empty_queue_generic(IocType IocId);

/*
 *  եå롼
 */
#ifdef CFG_USE_SYSTEM_ERRORHOOK
extern void ErrorHook(StatusType Error);
#endif /* CFG_USE_SYSTEM_ERRORHOOK */

#ifdef CFG_USE_PRETASKHOOK
extern void PreTaskHook(void);
#endif /* CFG_USE_PRETASKHOOK */

#ifdef CFG_USE_POSTTASKHOOK
extern void PostTaskHook(void);
#endif /* CFG_USE_POSTTASKHOOK */

#ifdef CFG_USE_SYSTEM_STARTUPHOOK
extern void StartupHook(void);
#endif /* CFG_USE_SYSTEM_STARTUPHOOK */

#ifdef CFG_USE_SYSTEM_SHUTDOWNHOOK
extern void ShutdownHook(StatusType Error);
#endif /* CFG_USE_SYSTEM_SHUTDOWNHOOK */

#ifdef CFG_USE_PROTECTIONHOOK
extern ProtectionReturnType ProtectionHook(StatusType FatalError);
#endif /* CFG_USE_PROTECTIONHOOK */

/*
 *  饤֥󶡤륷ƥॵӥ
 */
extern ApplicationType CheckObjectOwnership(ObjectTypeType ObjectType, ...);

/*
 *  եֹ̾λѤѿ
 */
extern const char8	*fatal_file_name;   /* ե̾ */
extern sint32		fatal_line_num;     /* ֹ */

#endif /* TOPPERS_MACRO_ONLY */

#if !defined(TOPPERS_CFG1_OUT) && !defined(OMIT_INCLUDE_OS_CFG) && !defined(OMIT_INCLUDE_OS_LCFG)
#include "Os_Lcfg.h"
#endif

/*
 *  OSΥ顼
 */
#define E_OS_ACCESS							UINT_C(1)
#define E_OS_CALLEVEL						UINT_C(2)
#define E_OS_ID								UINT_C(3)
#define E_OS_LIMIT							UINT_C(4)
#define E_OS_NOFUNC							UINT_C(5)
#define E_OS_RESOURCE						UINT_C(6)
#define E_OS_STATE							UINT_C(7)
#define E_OS_VALUE							UINT_C(8)
#define E_OS_SERVICEID						UINT_C(9)
#define E_OS_ILLEGAL_ADDRESS				UINT_C(10)
#define E_OS_MISSINGEND						UINT_C(11)
#define E_OS_DISABLEDINT					UINT_C(12)
#define E_OS_STACKFAULT						UINT_C(13)
#define E_OS_PROTECTION_MEMORY				UINT_C(14)
#define E_OS_PROTECTION_TIME_TASK			UINT_C(15)
#define E_OS_PROTECTION_TIME_ISR			UINT_C(16)
#define E_OS_PROTECTION_ARRIVAL_TASK		UINT_C(17)
#define E_OS_PROTECTION_ARRIVAL_ISR			UINT_C(18)
#define E_OS_PROTECTION_LOCKED_RESOURCE		UINT_C(19)
#define E_OS_PROTECTION_LOCKED_OSINT		UINT_C(20)
#define E_OS_PROTECTION_LOCKED_ALLINT		UINT_C(21)
#define E_OS_PROTECTION_EXCEPTION			UINT_C(22)
#define E_OS_PROTECTION_FATAL				UINT_C(23)
#define E_OS_MODE							UINT_C(24)
#define E_OS_SHUTDOWN_FATAL					UINT_C(25)
#define E_OS_PARAM_POINTER					UINT_C(26)
#define E_OS_SYS_ASSERT_FATAL				UINT_C(27)
#define E_OS_CORE							UINT_C(28)
#define E_OS_SPINLOCK						UINT_C(29)
#define E_OS_INTERFERENCE_DEADLOCK			UINT_C(30)
#define E_OS_NESTING_DEADLOCK				UINT_C(31)
#define E_OS_SHUTDOWN_OTHER_CORE			UINT_C(32)

/* AUTOSARR4.0.3Ȥθߴθ */
#define OS_E_PARAM_POINTER					E_OS_PARAM_POINTER

#define ERRCODE_NUM							UINT_C(33) /* 顼ɿ */

/*
 *  IOCΥ顼
 */
#define IOC_E_OK			UINT_C(0)
#define IOC_E_NOK			UINT_C(1)
#define IOC_E_LIMIT			UINT_C(130)
#define IOC_E_LOST_DATA		UINT_C(64)
#define IOC_E_NO_DATA		UINT_C(131)

/*
 *  ¾
 */
#define UINT32_INVALID		UINT_C(0xffffffff)
#define UINT8_INVALID		UINT_C(0xff)

#define SUSPENDED			((TaskStateType) 0) /* ٻ߾ */
#define RUNNING				((TaskStateType) 1) /* ¹Ծ */
#define READY				((TaskStateType) 2) /* ¹Բǽ */
#define WAITING				((TaskStateType) 3) /* Ԥ */

/*
 *  Ŭ뤿ᡤ¸Ǥκɬ
 */
#ifndef OMIT_DATA_TYPE
#define INVALID_TASK			((TaskType) UINT32_INVALID)
#define INVALID_ISR				((ISRType) UINT32_INVALID)
#endif /* OMIT_DATA_TYPE */
#define INVALID_APPMODETYPE		((AppModeType) UINT32_INVALID)
#define INVALID_OSAPPLICATION	((ApplicationType) UINT8_INVALID)
#define INVALID_SPINLOCK		((SpinlockIdType) 0)

/*
 *  StartOSΰ
 */
#define DONOTCARE			((AppModeType) UINT32_INVALID)

/*
 *  塼ơ֥Υơ
 */
#define SCHEDULETABLE_STOPPED					((ScheduleTableStatusType) 0x01)
#define SCHEDULETABLE_NEXT						((ScheduleTableStatusType) 0x02)
#define SCHEDULETABLE_WAITING					((ScheduleTableStatusType) 0x04)
#define SCHEDULETABLE_RUNNING					((ScheduleTableStatusType) 0x08)
#define SCHEDULETABLE_RUNNING_AND_SYNCHRONOUS	((ScheduleTableStatusType) 0x10)

/*
 *  ƥॵӥID
 */
#define OSServiceId_GetActiveApplicationMode	((OSServiceIdType) 0)
#define OSServiceId_StartOS						((OSServiceIdType) 1)
#define OSServiceId_ActivateTask				((OSServiceIdType) 3)
#define OSServiceId_TerminateTask				((OSServiceIdType) 4)
#define OSServiceId_ChainTask					((OSServiceIdType) 5)
#define OSServiceId_Schedule					((OSServiceIdType) 6)
#define OSServiceId_GetTaskID					((OSServiceIdType) 7)
#define OSServiceId_GetTaskState				((OSServiceIdType) 8)
#define OSServiceId_EnableAllInterrupts			((OSServiceIdType) 9)
#define OSServiceId_DisableAllInterrupts		((OSServiceIdType) 10)
#define OSServiceId_ResumeAllInterrupts			((OSServiceIdType) 11)
#define OSServiceId_SuspendAllInterrupts		((OSServiceIdType) 12)
#define OSServiceId_ResumeOSInterrupts			((OSServiceIdType) 13)
#define OSServiceId_SuspendOSInterrupts			((OSServiceIdType) 14)
#define OSServiceId_GetISRID					((OSServiceIdType) 15)
#define OSServiceId_SetEvent					((OSServiceIdType) 16)
#define OSServiceId_ClearEvent					((OSServiceIdType) 17)
#define OSServiceId_GetEvent					((OSServiceIdType) 18)
#define OSServiceId_WaitEvent					((OSServiceIdType) 19)
#define OSServiceId_GetResource					((OSServiceIdType) 20)
#define OSServiceId_ReleaseResource				((OSServiceIdType) 21)
#define OSServiceId_IncrementCounter			((OSServiceIdType) 22)
#define OSServiceId_GetCounterValue				((OSServiceIdType) 23)
#define OSServiceId_GetElapsedValue				((OSServiceIdType) 24)
#define OSServiceId_GetAlarmBase				((OSServiceIdType) 25)
#define OSServiceId_GetAlarm					((OSServiceIdType) 26)
#define OSServiceId_SetRelAlarm					((OSServiceIdType) 27)
#define OSServiceId_SetAbsAlarm					((OSServiceIdType) 28)
#define OSServiceId_CancelAlarm					((OSServiceIdType) 29)
#define OSServiceId_StartScheduleTableRel		((OSServiceIdType) 30)
#define OSServiceId_StartScheduleTableAbs		((OSServiceIdType) 31)
#define OSServiceId_StopScheduleTable			((OSServiceIdType) 32)
#define OSServiceId_NextScheduleTable			((OSServiceIdType) 33)
#define OSServiceId_GetScheduleTableStatus		((OSServiceIdType) 34)
#define OSServiceId_TaskMissingEnd				((OSServiceIdType) 35)
#define OSServiceId_ISRMissingEnd				((OSServiceIdType) 36)
#define OSServiceId_HookMissingEnd				((OSServiceIdType) 37)
#define OSServiceId_GetApplicationID			((OSServiceIdType) 38)
#define OSServiceId_CheckTaskOwnership			((OSServiceIdType) 50)
#define OSServiceId_CheckISROwnership			((OSServiceIdType) 51)
#define OSServiceId_CheckAlarmOwnership			((OSServiceIdType) 52)
#define OSServiceId_CheckCounterOwnership		((OSServiceIdType) 53)
#define OSServiceId_CheckScheduleTableOwnership	((OSServiceIdType) 54)
#define IOCServiceId_IOC_Send					((OSServiceIdType) 56)
#define IOCServiceId_IOC_Write					((OSServiceIdType) 57)
#define IOCServiceId_IOC_SendGroup				((OSServiceIdType) 58)
#define IOCServiceId_IOC_WriteGroup				((OSServiceIdType) 59)
#define IOCServiceId_IOC_Receive				((OSServiceIdType) 60)
#define IOCServiceId_IOC_Read					((OSServiceIdType) 61)
#define IOCServiceId_IOC_ReceiveGroup			((OSServiceIdType) 62)
#define IOCServiceId_IOC_ReadGroup				((OSServiceIdType) 63)
#define IOCServiceId_IOC_EmptyQueue				((OSServiceIdType) 64)
#define OSServiceId_StartCore					((OSServiceIdType) 67)
#define OSServiceId_StartNonAutosarCore			((OSServiceIdType) 68)
#define OSServiceId_ShutdownAllCores			((OSServiceIdType) 69)
#define OSServiceId_GetSpinlock					((OSServiceIdType) 70)
#define OSServiceId_ReleaseSpinlock				((OSServiceIdType) 71)
#define OSServiceId_TryToGetSpinlock			((OSServiceIdType) 72)
#define OSServiceId_RaiseInterCoreInterrupt		((OSServiceIdType) 73)

/*
 *  ݸȿ򵯤ñ̤
 */
#define FC_INVALID			UINT_C(0x00)        /* ݸȿ򵯤ñ̤Ǥʤ */
#define FC_TASK				UINT_C(0x01)        /* ݸȿ򵯤ñ̤ */
#define FC_C2ISR			UINT_C(0x02)        /* ݸȿ򵯤ñ̤C2ISR */
#define FC_SYSTEM_HOOK		UINT_C(0x03)        /* ݸȿ򵯤ñ̤ƥΥեå */
#define FC_OSAP_HOOK		UINT_C(0x04)        /* ݸȿ򵯤ñ̤OSAPͭΥեå */

/*
 *  顼եåOFFӥIDȥѥ᡼OFFˤʤ
 */
#ifdef CFG_USE_ERRORHOOK

/*
 *  ޥ
 */
#ifdef CFG_USE_GETSERVICEID
#ifndef TOPPERS_MACRO_ONLY
extern OSServiceIdType get_error_svcid(void);
#endif /* TOPPERS_MACRO_ONLY */
#define OSErrorGetServiceId()				get_error_svcid()
#endif /* CFG_USE_GETSERVICEID */

#ifdef CFG_USE_PARAMETERACCESS

#ifndef TOPPERS_MACRO_ONLY

extern void get_error_par(_ErrorHook_Par *p_errorhook_par, uint8 par_num);
LOCAL_INLINE _ErrorHook_Par
get_error_par1(void)
{
	_ErrorHook_Par errorhook_par;
	get_error_par(&errorhook_par, 1U);
	return(errorhook_par);
}
LOCAL_INLINE _ErrorHook_Par
get_error_par2(void)
{
	_ErrorHook_Par errorhook_par;
	get_error_par(&errorhook_par, 2U);
	return(errorhook_par);
}
LOCAL_INLINE _ErrorHook_Par
get_error_par3(void)
{
	_ErrorHook_Par errorhook_par;
	get_error_par(&errorhook_par, 3U);
	return(errorhook_par);
}
#endif /* TOPPERS_MACRO_ONLY */

/*
 *  顼ƥॵӥID
 */
#define OSError_StartOS_Mode()									(get_error_par1().mode)
#define OSError_ActivateTask_TaskID()							(get_error_par1().tskid)
#define OSError_ChainTask_TaskID()								(get_error_par1().tskid)
#define OSError_GetTaskID_TaskID()								(get_error_par1().p_tskid)
#define OSError_GetTaskState_TaskID()							(get_error_par1().tskid)
#define OSError_GetTaskState_State()							(get_error_par2().p_stat)
#define OSError_GetResource_ResID()								(get_error_par1().resid)
#define OSError_ReleaseResource_ResID()							(get_error_par1().resid)
#define OSError_SetEvent_TaskID()								(get_error_par1().tskid)
#define OSError_SetEvent_Mask()									(get_error_par2().mask)
#define OSError_ClearEvent_Mask()								(get_error_par1().mask)
#define OSError_GetEvent_TaskID()								(get_error_par1().tskid)
#define OSError_GetEvent_Event()								(get_error_par2().p_mask)
#define OSError_WaitEvent_Mask()								(get_error_par1().mask)
#define OSError_GetAlarmBase_AlarmID()							(get_error_par1().almid)
#define OSError_GetAlarmBase_Info()								(get_error_par2().p_info)
#define OSError_GetAlarm_AlarmID()								(get_error_par1().almid)
#define OSError_GetAlarm_Tick()									(get_error_par2().p_tick)
#define OSError_SetRelAlarm_AlarmID()							(get_error_par1().almid)
#define OSError_SetRelAlarm_increment()							(get_error_par2().incr)
#define OSError_SetRelAlarm_cycle()								(get_error_par3().cycle)
#define OSError_SetAbsAlarm_AlarmID()							(get_error_par1().almid)
#define OSError_SetAbsAlarm_start()								(get_error_par2().start)
#define OSError_SetAbsAlarm_cycle()								(get_error_par3().cycle)
#define OSError_CancelAlarm_AlarmID()							(get_error_par1().almid)
#define OSError_IncrementCounter_CounterID()					(get_error_par1().cntid)
#define OSError_GetCounterValue_CounterID()						(get_error_par1().cntid)
#define OSError_GetCounterValue_Value()							(get_error_par2().p_val)
#define OSError_GetElapsedValue_CounterID()						(get_error_par1().cntid)
#define OSError_GetElapsedValue_Value()							(get_error_par2().p_val)
#define OSError_GetElapsedValue_ElapsedValue()					(get_error_par3().p_eval)
#define OSError_StartScheduleTableRel_ScheduleTableID()			(get_error_par1().schtblid)
#define OSError_StartScheduleTableRel_Offset()					(get_error_par2().offset)
#define OSError_StartScheduleTableAbs_ScheduleTableID()			(get_error_par1().schtblid)
#define OSError_StartScheduleTableAbs_Start()					(get_error_par2().start)
#define OSError_StopScheduleTable_ScheduleTableID()				(get_error_par1().schtblid)
#define OSError_NextScheduleTable_ScheduleTableID_From()		(get_error_par1().schtblid_from)
#define OSError_NextScheduleTable_ScheduleTableID_To()			(get_error_par2().schtblid_to)
#define OSError_GetScheduleTableStatus_ScheduleTableID()		(get_error_par1().schtblid)
#define OSError_GetScheduleTableStatus_ScheduleStatus()			(get_error_par2().p_schtblstate)
#define OSError_CheckTaskOwnership_TaskID()						(get_error_par1().tskid)
#define OSError_CheckISROwnership_ISRID()						(get_error_par1().isrid)
#define OSError_CheckAlarmOwnership_AlarmID()					(get_error_par1().almid)
#define OSError_CheckCounterOwnership_CounterID()				(get_error_par1().cntid)
#define OSError_CheckScheduleTableOwnership_ScheduleTableID()	(get_error_par1().schtblid)
#define OSError_StartCore_CoreID()								(get_error_par1().coreid)
#define OSError_StartCore_Status()								(get_error_par2().status)
#define OSError_StartNonAutosarCore_CoreID()					(get_error_par1().coreid)
#define OSError_StartNonAutosarCore_Status()					(get_error_par2().status)
#define OSError_GetSpinlock_SpinlockId()						(get_error_par1().spnid)
#define OSError_ReleaseSpinlock_SpinlockId()					(get_error_par1().spnid)
#define OSError_TryToGetSpinlock_SpinlockId()					(get_error_par1().spnid)
#define OSError_TryToGetSpinlock_Success()						(get_error_par2().tryspntype)
#define OSError_IocSend_IocId()									(get_error_par1().iocid)
#define OSError_IocSend_SenderId()								(get_error_par2().senderid)
#define OSError_IocWrite_IocId()								(get_error_par1().iocid)
#define OSError_IocWrite_SenderId()								(get_error_par2().senderid)
#define OSError_IocReceive_IocId()								(get_error_par1().iocid)
#define OSError_IocRead_IocId()									(get_error_par1().iocid)
#define OSError_IocEmptyQueue_IocId()							(get_error_par1().iocid)
#define OSError_RaiseInterCoreInterrupt_ISRID()					(get_error_par1().isrid)

#endif /* CFG_USE_PARAMETERACCESS */

#endif /* CFG_USE_ERRORHOOK */

/*
 *  ץƥեåطΥޥ
 */
#define PRO_IGNORE					UINT_C(0x00)
#define PRO_SHUTDOWN				UINT_C(0x01)

/*
 *   ֥ȥ
 */
#define OBJECT_TASK				UINT_C(0x01)
#define OBJECT_ISR				UINT_C(0x02)
#define OBJECT_ALARM			UINT_C(0x03)
#define OBJECT_RESOURCE			UINT_C(0x04)
#define OBJECT_COUNTER			UINT_C(0x05)
#define OBJECT_SCHEDULETABLE	UINT_C(0x06)

/*
 *  С
 */
#define OS_SW_MAJOR_VERSION				UINT_C(1)   /* ץ饤䡼С */
#define OS_SW_MINOR_VERSION				UINT_C(2)
#define OS_SW_PATCH_VERSION				UINT_C(1)

#define OS_AR_RELEASE_MAJOR_VERSION		UINT_C(4)   /* AUTOSAR꡼С */
#define OS_AR_RELEASE_MINOR_VERSION		UINT_C(0)
#define OS_AR_RELEASE_REVISION_VERSION	UINT_C(3)

#define TKERNEL_NAME	"TOPPERS/ATK2-SC1-MC"  /* ͥ̾Ρȼ͡ */

#endif /* TOPPERS_OS_H */
