/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2014 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2014 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2014 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2004-2014 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: counter.c 345 2014-09-16 23:55:32Z fsi-dankei $
 */

/*
 *		⥸塼
 */

#include "kernel_impl.h"
#include "task.h"
#include "counter.h"

/*
 *  ȥ졼ޥΥǥե
 */
#ifndef LOG_INCCNT_ENTER
#define LOG_INCCNT_ENTER(cntid)
#endif /* LOG_INCCNT_ENTER */

#ifndef LOG_INCCNT_LEAVE
#define LOG_INCCNT_LEAVE(ercd)
#endif /* LOG_INCCNT_LEAVE */

#ifndef LOG_GETCNT_ENTER
#define LOG_GETCNT_ENTER(cntid, p_val)
#endif /* LOG_GETCNT_ENTER */

#ifndef LOG_GETCNT_LEAVE
#define LOG_GETCNT_LEAVE(ercd, val)
#endif /* LOG_GETCNT_LEAVE */

#ifndef LOG_GETECT_ENTER
#define LOG_GETECT_ENTER(cntid, val, p_eval)
#endif /* LOG_GETECT_ENTER */

#ifndef LOG_GETECT_LEAVE
#define LOG_GETECT_LEAVE(ercd, val, eval)
#endif /* LOG_GETECT_LEAVE */

/*
 *  λ塼ؤ
 */
#ifdef TOPPERS_insert_cnt_expr_que

void
insert_cnt_expr_que(CNTEXPINFO *p_cntexpinfo, const CNTCB *p_cntcb)
{
	TickType	enqval, curval;
	QUEUE		*next;
	CounterType cntid;

	enqval = p_cntexpinfo->expiretick;

	/*
	 *  λ塼ؤ֤ꤹ뤿δ
	 *
	 *  ϡɥ󥿤ξ硤λ塼ؤ֤
	 *  λ˹ƤͤѤϡɥ鸽ͤϤʤ
	 *  (ϡɥ󥿾ΥƥåͤλƤ뤬ޤλ¹Ԥ
	 *  ʤˡδबƤޤ)
	 */
	curval = p_cntcb->curval;

	/* Υ */
	next = p_cntcb->cntexpque.p_next;

	if (curval < enqval) {
		/* 󥿤ΥСեʤ */
		while ((next != &(p_cntcb->cntexpque)) &&
			   (curval <= ((CNTEXPINFO *) next)->expiretick) &&
			   (((CNTEXPINFO *) next)->expiretick <= enqval)) {
			next = next->p_next;
		}
	}
	else {
		/* 󥿤ΥСե */
		while ((next != &(p_cntcb->cntexpque)) &&
			   ((curval <= ((CNTEXPINFO *) next)->expiretick)
				|| (((CNTEXPINFO *) next)->expiretick <= enqval))) {
			next = next->p_next;
		}
	}

	queue_insert_prev(next, &(p_cntexpinfo->cntexpque));

	/*
	 *  ϡɥ󥿤Ƭ,٥ϡɥ󥿤
	 *  λ֤ꤷľɬפ
	 */
	cntid = CNTID(p_cntcb);
	if (is_hwcnt(cntid) && (p_cntcb->cntexpque.p_next == &(p_cntexpinfo->cntexpque))) {

		/* ꤵƤ򥭥󥻥 */
		(hwcntinib_table[cntid].cancel)();

		/* Ƭ˺ */
		(hwcntinib_table[cntid].set)(enqval);

		/*
		 *  ˼λ֤᤮Ƥޤäå
		 *
		 *  ᤮Ƥޤä, ߤˤλ¹Ԥ
		 *  ޤset֤get֤ƱǤä,
		 *  ϡɥǼꤳܤƤꤷ, ߤȯ
		 *  ϡɥǼꤳܤƤʤ˶ߤ򵯤Ƥʤ
		 */
		if (diff_tick((hwcntinib_table[cntid].get)(), enqval,
					  p_cntcb->p_cntinib->maxval2) <= p_cntcb->p_cntinib->maxval) {
			/* ꤵƤ򥭥󥻥 */
			(hwcntinib_table[cntid].cancel)();
			/* ߤȯ */
			(hwcntinib_table[cntid].trigger)();
		}
	}
}

#endif /* TOPPERS_insert_cnt_expr_que */

/*
 *  λ塼
 */
#ifdef TOPPERS_delete_cnt_expr_que

void
delete_cnt_expr_que(CNTEXPINFO *p_cntexpinfo, const CNTCB *p_cntcb)
{
	CounterType cntid;
	QUEUE		*p_cntexpque;

	/* 󥿥塼λƬ塼ݻ */
	p_cntexpque = p_cntcb->cntexpque.p_next;

	queue_delete(&(p_cntexpinfo->cntexpque));
	queue_initialize(&(p_cntexpinfo->cntexpque));

	/*
	 *  ϡɥ󥿤ĺλϥλ
	 *  Ƭξ硤ޤ򥭥󥻥뤹
	 */
	cntid = CNTID(p_cntcb);
	if (is_hwcnt(cntid) && (p_cntcb->cntexpque.p_next != p_cntexpque)) {

		/* ꤵƤ򥭥󥻥 */
		(hwcntinib_table[cntid].cancel)();

		/* ڥǥγ׵򥭥󥻥 */
		(hwcntinib_table[cntid].intcancel)();

		/*
		 *  p_cntexpinfoǻꤵ줿λ塤λ
		 *  λλꤹ
		 */
		if (queue_empty(&(p_cntcb->cntexpque)) == FALSE) {

			/* Ƭ˺ */
			(hwcntinib_table[cntid].set)(((CNTEXPINFO *) p_cntcb->cntexpque.p_next)->expiretick);

			/*
			 *  ˼λ֤᤮Ƥޤäå
			 *
			 *  ᤮Ƥޤä, ߤˤλ¹Ԥ
			 *  ޤset֤get֤ƱǤä,
			 *  ϡɥǼꤳܤƤꤷ, ߤȯ
			 *  ϡɥǼꤳܤƤʤ˶ߤ򵯤Ƥʤ
			 */
			if (diff_tick((hwcntinib_table[cntid].get)(),
						  ((CNTEXPINFO *) p_cntcb->cntexpque.p_next)->expiretick,
						  p_cntcb->p_cntinib->maxval2) <= p_cntcb->p_cntinib->maxval) {
				/* ꤵƤ򥭥󥻥 */
				(hwcntinib_table[cntid].cancel)();
				/* ߤȯ */
				(hwcntinib_table[cntid].trigger)();
			}
		}
	}

}

#endif /* TOPPERS_delete_cnt_expr_que */

/*
 *  󥿵ǽν
 */
#ifdef TOPPERS_counter_initialize

void
counter_initialize(void)
{
	CounterType	i;
	CNTCB		*p_cntcb;
	CoreIdType	coreid = x_core_id();

	for (i = 0U; i < tnum_counter; i++) {
		if (cntinib_table[i].coreid == coreid) {
			p_cntcb = p_cntcb_table[i];
			p_cntcb->p_cntinib = &(cntinib_table[i]);
			p_cntcb->curval = 0U;
			queue_initialize(&(p_cntcb->cntexpque));
			p_cntcb->cstat = CS_NULL;
		}
	}

	for (i = 0U; i < tnum_hardcounter; i++) {
		if (hwcntinib_table[i].coreid == coreid) {
			(hwcntinib_table[i].init)(cntinib_table[i].maxval2,
									  hwcntinib_table[i].nspertick);
			(hwcntinib_table[i].start)();
		}
	}

}

#endif /* TOPPERS_counter_initialize */

/*
 *  󥿵ǽνλ
 */
#ifdef TOPPERS_counter_terminate

void
counter_terminate(void)
{
	CounterType i;

	for (i = 0U; i < tnum_hardcounter; i++) {
		(hwcntinib_table[i].stop)();
	}
}

#endif /* TOPPERS_counter_terminate */

/*
 *  ꤷл֤Υͼ(APIμ)
 *
 *  ꤷ󥿤θͤ, Ϥ줿ͤ­߹ͤ
 *  ͤȤ֤
 */
#ifdef TOPPERS_get_reltick

TickType
get_reltick(const CNTCB *p_cntcb, TickType relval)
{
	CounterType	cntid;
	TickType	result;
	TickType	curval;

	cntid = CNTID(p_cntcb);

	curval = get_curval(p_cntcb, cntid);

	/* ߻֤ꤵ줿եåʬ᤮֤򻻽Ф */
	result = add_tick(curval, relval, p_cntcb->p_cntinib->maxval2);

	return(result);
}

#endif /* TOPPERS_get_reltick */

/*
 *  ꤷл֤Υͼ(APIμ)
 *
 *  Ϥ줿ͤꤷ󥿤θͤѴ
 *  ͤͤȤ֤
 */
#ifdef TOPPERS_get_abstick

TickType
get_abstick(const CNTCB *p_cntcb, TickType absval)
{
	CounterType	cntid;
	TickType	result;
	TickType	curval;
	TickType	nextval;

	cntid = CNTID(p_cntcb);

	curval = get_curval(p_cntcb, cntid);

	/* maxval2θл֤Ѵ */
	nextval = absval +  p_cntcb->p_cntinib->maxval + 1U;

	if (curval < (p_cntcb->p_cntinib->maxval + 1U)) {
		/*
		 *  󥿤θͤ0maxvalδ֤ξ硤
		 *  л̤ãʤΤǡл֤
		 */
		if (absval > curval) {
			result = absval;
		}
		else {
			result = nextval;
		}
	}
	else {
		/*
		 *  󥿤θͤmaxvalmaxval2δ֤ξ硤
		 *  maxval2θФĶΤǡл֤
		 */
		if (nextval <= curval) {
			result = absval;
		}
		else {
			result = nextval;
		}
	}

	return(result);
}

#endif /* TOPPERS_get_abstick */

/*
 *  󥿤λ
 */
#ifdef TOPPERS_expire_process

void
expire_process(CNTCB *p_cntcb, CounterType cntid)
{
	CNTEXPINFO	*p_cntexpinfo;
	TickType	nowval;
	boolean		dspreq;
	CCB			*p_ccb = get_p_ccb(p_cntcb->p_cntinib->coreid);

	nowval = get_curval(p_cntcb, cntid);

	/*
	 *  󥿤λ
	 *
	 *  塼Ǥʤ, ꥢ륿ʸ߻֤鸫ƥ塼Ƭλ
	 *  ֤˲᤮Ƥ, λ¹Ԥ
	 *
	 *  ꥢ륿ʸ߻֤򤽤ټ뤿,塼Ƭλ
	 *  λ֤ꤹŪλ֤ĶƤޤäƤ⥫С
	 *  Ǥ
	 */
	while ((queue_empty(&(p_cntcb->cntexpque)) == FALSE) &&
		   (diff_tick(nowval, ((CNTEXPINFO *) p_cntcb->cntexpque.p_next)->expiretick,
					  p_cntcb->p_cntinib->maxval2) <= p_cntcb->p_cntinib->maxval)) {

		/* λ塼Ƭλ򡤥塼鳰 */
		p_cntexpinfo = (CNTEXPINFO *) p_cntcb->cntexpque.p_next;
		queue_delete(&(p_cntexpinfo->cntexpque));
		queue_initialize(&(p_cntexpinfo->cntexpque));

		if (is_hwcnt(cntid)) {
			/*
			 *  ͤλλǹλ塼λ
			 *  λ塼Ӥ˻
			 */
			p_cntcb->curval = p_cntexpinfo->expiretick;

			/*
			 *  λ
			 *  λ»֤вᤷƤʤꤹ
			 */
			if ((queue_empty(&(p_cntcb->cntexpque)) == FALSE) && ((diff_tick((hwcntinib_table[cntid].get)(),
																			 ((CNTEXPINFO *) p_cntcb->cntexpque.p_next)->expiretick, p_cntcb->p_cntinib->maxval2)) >
																  p_cntcb->p_cntinib->maxval)) {
				(hwcntinib_table[cntid].set)(((CNTEXPINFO *) p_cntcb->cntexpque.p_next)->expiretick);
			}
		}

		/* λƽФ */
		(p_cntexpinfo->expirefunc)(p_cntexpinfo, p_cntcb);

		/*
		 *  θƤӽФͥ٥ǥ֤ˤʤä礢Τǡ
		 *  åƥǥѥå
		 */
		release_cnt_lock(p_ccb);
		acquire_tsk_lock(p_ccb);
		if ((p_ccb->p_runtsk != p_ccb->p_schedtsk) && (p_ccb->callevel_stat == TCL_TASK)) {
			dspreq = TRUE;
		}
		else {
			dspreq = FALSE;
		}
		release_tsk_lock_and_dispatch(p_ccb, dspreq);

		/*
		 *  ߥ쥹ݥ󥹹θ1Ĥλ
		 *  1γ/ػߤ»
		 */
		x_nested_unlock_os_int();
		x_nested_lock_os_int();
		acquire_cnt_lock(p_ccb);

		nowval = get_curval(p_cntcb, cntid);
	}
}
#endif /* TOPPERS_expire_process */
