/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2014 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2014 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2014 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2004-2014 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: osctl_manage.c 345 2014-09-16 23:55:32Z fsi-dankei $
 */

/*
 *		OS⥸塼
 */

#include "kernel_impl.h"
#include "check.h"
#include "interrupt.h"
#include "mc.h"

/*
 *  ȥ졼ޥΥǥե
 */
#ifndef LOG_GETAAM_ENTER
#define LOG_GETAAM_ENTER()
#endif /* LOG_GETAAM_ENTER */

#ifndef LOG_GETAAM_LEAVE
#define LOG_GETAAM_LEAVE(mode)
#endif /* LOG_GETAAM_LEAVE */

#ifndef LOG_STAOS_ENTER
#define LOG_STAOS_ENTER(mode)
#endif /* LOG_STAOS_ENTER */

#ifndef LOG_STAOS_LEAVE
#define LOG_STAOS_LEAVE()
#endif /* LOG_STAOS_LEAVE */

#ifndef LOG_STAHOOK_ENTER
#define LOG_STAHOOK_ENTER()
#endif /* LOG_STAHOOK_ENTER */

#ifndef LOG_STAHOOK_LEAVE
#define LOG_STAHOOK_LEAVE()
#endif /* LOG_STAHOOK_LEAVE */

#ifndef LOG_STAHOOKOSAP_ENTER
#define LOG_STAHOOKOSAP_ENTER(index)
#endif /* LOG_STAHOOKOSAP_ENTER */

#ifndef LOG_STAHOOKOSAP_LEAVE
#define LOG_STAHOOKOSAP_LEAVE(index)
#endif /* LOG_STAHOOKOSAP_LEAVE */

#ifdef TOPPERS_StartOS

/*
 *  OS¹Τѿ
 */
AppModeType	appmodeid;                                              /* ץꥱ⡼ID */

/*
 *  եֹ̾λѤѿ
 */
const char8	*fatal_file_name = NULL;                    /* ե̾ */
sint32		fatal_line_num = 0;                         /* ֹ */


/*
 *  OSεư
 */

void
StartOS(AppModeType Mode)
{
	static AppModeType	appmodeid_table[TotalNumberOfCores];             /* ƥΥץꥱ⡼ID */
	static boolean		os_controlled[TotalNumberOfCores] = {
		FALSE
	};                                                                   /* OSɤFALSE0Ǥʤʤ */

#ifdef CFG_USE_STARTUPHOOK
	void (*volatile startuphook_adr) (void);
#ifdef CFG_USE_OSAP_STARTUPHOOK
	ApplicationType		i;
#endif /* CFG_USE_OSAP_STARTUPHOOK */
#endif /* CFG_USE_STARTUPHOOK */

	CCB					*p_ccb = get_my_p_ccb();
	CoreIdType			coreid;
	CoreIdType			my_coreid = x_core_id();
	AppModeType			appmodeid_local = DONOTCARE;

	LOG_STAOS_ENTER(Mode);
	/*
	 *  IDTotalNumberOfCores礭ϡ
	 *  CCB¸ߤʤΤǡ⤻return
	 */
#ifdef CFG_USE_EXTENDEDSTATUS
	if (my_coreid < TotalNumberOfCores) {
		if (p_ccb->kerflg != FALSE) {
			/* OSưϥ顼եåƤ */
#ifdef CFG_USE_ERRORHOOK
			x_nested_lock_os_int();
#ifdef CFG_USE_PARAMETERACCESS
			p_ccb->_errorhook_par1.mode = Mode;
#endif /* CFG_USE_PARAMETERACCESS */
			call_errorhook(E_OS_ACCESS, OSServiceId_StartOS);
			x_nested_unlock_os_int();
#endif /* CFG_USE_ERRORHOOK */
		}
		else {
#endif /* CFG_USE_EXTENDEDSTATUS */

			/* ߶ػ߾֤˰ܹ */
			x_lock_all_int();

#ifdef CFG_USE_STACKMONITORING
			/*
			 *  å˥󥰵ǽν
			 *  å˥󥰵ǽΤΥޥåʥСΰν
			 */
			init_stack_magic_region();
#endif /* CFG_USE_STACKMONITORING */

			/*
			 * ޥˤĤƤTRUEȤ뤿ᡤ
			 * StartCoreǤϤʤǽ
			 */
			os_controlled[my_coreid] = TRUE;

			/* ץꥱ⡼ɤ */
			appmodeid_table[my_coreid] = Mode;

			if (x_sense_mcore() != FALSE) {
				p_inib_initialize();
			}

			barrier_sync(1U, FALSE);

			/* ץꥱ⡼ɤΥå */
			for (coreid = 0U; coreid < TotalNumberOfCores; coreid++) {
				if ((os_controlled[coreid] != FALSE) && (appmodeid_table[coreid] != DONOTCARE)) {
					/* ۤʤ륢ץꥱ⡼ɤꤵ줿̵¥롼 */
					if ((appmodeid_local != appmodeid_table[coreid]) && (appmodeid_local != DONOTCARE)) {
						while (1) {
						}
					}
					appmodeid_local = appmodeid_table[coreid];
				}
			}
			/* ٤DONOTCAREʤ̵¥롼 */
			if (appmodeid_local == DONOTCARE) {
				while (1) {
				}
			}
			appmodeid = appmodeid_local;

			/*
			 *  ֥å
			 */
			ccb_initialize();

			/* åȰ¸ν */
			target_initialize();

			/* ƥ⥸塼ν */
			object_initialize();

			p_ccb->callevel_stat = TCL_NULL;

			/* ͥư */
			p_ccb->kerflg = TRUE;

			/*
			 *  ModeǤä硤OSåȥԤ
			 *  λȥåץեåϸƤӽФʤ
			 */
			if (appmodeid >= tnum_appmode) {
				/*
				 *  internal_shutdownallcoresƤOS߶ػ߾֤
				 *  ߶ػ߾ֲ
				 */
				x_nested_lock_os_int();
				x_unlock_all_int();
				internal_shutdownallcores(E_OS_MODE);
			}

			barrier_sync(2U, FALSE);

#ifdef CFG_USE_STARTUPHOOK
			/* OS߶ػ߾֤ˤ߶ػ߾ֲ */
			x_nested_lock_os_int();
			x_unlock_all_int();

#ifdef CFG_USE_SYSTEM_STARTUPHOOK
			/*
			 *  StartupHook θƤӽФ
			 *
			 *  CεʤǤϴؿΥɥ쥹0ˤʤʤȤ󤫤,
			 *  ѥκŬˤStartupHookΥɥ쥹Ƚʬ
			 *  Ƥޤ礬뤿, volatileꤷѿ
			 *  ɥ쥹ƤȽꤷƤ
			 */
			startuphook_adr = &StartupHook;

			if (startuphook_adr != NULL) {
				ENTER_CALLEVEL(TCL_SYS_STARTUP);
				LOG_STAHOOK_ENTER();
				StartupHook();
				LOG_STAHOOK_LEAVE();
				LEAVE_CALLEVEL(TCL_SYS_STARTUP);

				release_interrupts(OSServiceId_HookMissingEnd);
			}
#endif /* CFG_USE_SYSTEM_STARTUPHOOK */

#ifdef CFG_USE_OSAP_STARTUPHOOK
			/*
			 *  OSץꥱStartUpHookƽФ
			 *
			 *  OSץꥱ֥åꤵ줿ȥ꤬
			 *  NULLǤʤм¹Ԥ
			 */
			for (i = 0U; i < tnum_osap; i++) {
				if (osapinib_table[i].coreid == my_coreid) {
					startuphook_adr = osapinib_table[i].StartupHook;
					p_ccb->p_runosap = &(osapinib_table[i]);
					if (startuphook_adr != NULL) {
						ENTER_CALLEVEL(TCL_OSAP_STARTUP);
						LOG_STAHOOKOSAP_ENTER(i);
						startuphook_adr();
						LOG_STAHOOKOSAP_LEAVE(i);
						LEAVE_CALLEVEL(TCL_OSAP_STARTUP);

						release_interrupts(OSServiceId_HookMissingEnd);
					}
				}
			}
			/*
			 *  ʲιԤϤʤƤƶϤʤɥ롼פǤξ֤
			 *  OSAPʤξ֤ˤ
			 */
			p_ccb->p_runosap = NULL;
#endif /* CFG_USE_OSAP_STARTUPHOOK */

			/* γߥޥͥ٤߶ػ߾֤ */
			x_lock_all_int();
			x_nested_unlock_os_int();
#endif /* CFG_USE_STARTUPHOOK */

			ENTER_CALLEVEL(TCL_TASK);

			/*
			 * ȥåץեåOSΥåȥԤȡʲ
			 * ХꥢƱԤäƤ륳˳ߤʤᡤå
			 * ³뤳ȤǤʤʤ롥ɤˡ
			 * åȥ׵᤬ФƤ뤫å롥
			 */
			barrier_sync(3U, TRUE);
			LOG_STAOS_LEAVE();
			start_dispatch();
			ASSERT(0);
#ifdef CFG_USE_EXTENDEDSTATUS
		}
	}
#endif /* CFG_USE_EXTENDEDSTATUS */
}

#endif /* TOPPERS_StartOS */

/*
 *  ߤΥץꥱ⡼ɤμ
 */
#ifdef TOPPERS_GetActiveApplicationMode

AppModeType
GetActiveApplicationMode(void)
{
	AppModeType	appmode;
#if defined(CFG_USE_EXTENDEDSTATUS) || defined(CFG_USE_ERRORHOOK)
	StatusType ercd;
#endif /* CFG_USE_EXTENDEDSTATUS || CFG_USE_ERRORHOOK */

	LOG_GETAAM_ENTER();
	CHECK_DISABLEDINT();
	CHECK_CALLEVEL(CALLEVEL_GETACTIVEAPPMODE);

	appmode = appmodeid;

  exit_finish:
	LOG_GETAAM_LEAVE(appmode);
	return(appmode);

#ifdef CFG_USE_ERRORHOOK
  exit_errorhook:
	x_nested_lock_os_int();
	/*
	 *  顼ȯINVALID_APPMODETYPE֤뤬顼ȯΤ¹
	 *  C2ISR¸ߤʤΤ̤뤿ᡤ顼եåƤ
	 */
	call_errorhook(ercd, OSServiceId_GetActiveApplicationMode);
	x_nested_unlock_os_int();
#endif /* CFG_USE_ERRORHOOK */

  exit_no_errorhook:
	appmode = INVALID_APPMODETYPE;
	goto exit_finish;
}

#endif /* TOPPERS_GetActiveApplicationMode */

/*
 *  ݸȿ򵯤ñ̤μ
 */
#ifdef TOPPERS_GetFaultyContext

FaultyContextType
GetFaultyContext(void)
{
	FaultyContextType faultycontext = FC_INVALID;

#ifdef CFG_USE_PROTECTIONHOOK
	CCB    *p_ccb = get_my_p_ccb();
	uint16 callevel_stat = p_ccb->callevel_stat;

	if ((callevel_stat & CALLEVEL_GETFAULTYCONTEXT) != 0U) {

		/* C1ISRʳȯ */
		if ((callevel_stat & TSYS_ISR1) == 0U) {
			/* եåȯ */
			if ((callevel_stat & (TCL_ERROR | TCL_PREPOST | TCL_STARTUP | TCL_SHUTDOWN)) != 0U) {
				if ((callevel_stat & TCL_OSAP_MASK) != 0U) {
					/* OSAP°Υեåȯ */
					faultycontext = FC_OSAP_HOOK;
				}
				else {
					/* ƥեåȯ */
					faultycontext = FC_SYSTEM_HOOK;
				}
			}
			else if ((callevel_stat & TCL_ISR2) != 0U) {
				if ((callevel_stat & TCL_ALRMCBAK) == 0U) {
					faultycontext = FC_C2ISR;
				}
			}
			else if ((callevel_stat & TCL_TASK) != 0U) {
				if ((callevel_stat & TCL_ALRMCBAK) == 0U) {
					faultycontext = FC_TASK;
				}
			}
			else {
				/* 嵭ʳξ硤ϹԤʤ(͡FC_INVALID) */
			}
		}
	}
#endif /* CFG_USE_PROTECTIONHOOK */

	return(faultycontext);
}
#endif /* TOPPERS_GetFaultyContext */
